/**
 * OpticalFlow example for the
 * Computer Vision Techniques for Musical Interaction - Using Processing 
 * session of the
 * Computer Music Doctoral Program
 * http://www.artes.ucp.pt/si/doutoramento/index.html
 * 
 * author: Jorge Cardoso
 * http://jorgecardoso.eu
 * May 2009
 */
import processing.opengl.*;

import processing.video.*;

import org.jorgecardoso.processing.opticalflow.*;


Capture cap;
OpticalFlow of;
int blockSize = 20;
PImage prev;

void setup() {
  size(640, 480, OPENGL);
  of = new OpticalFlow();
  cap = new Capture(this, 320, 200);
  cap.read();
  prev = new PImage(320, 200);
  arraycopy(cap.pixels, prev.pixels);
}


void draw() {
  background(0);
  stroke(255);
  cap.read();
  image(cap, 0, 0, width, height);
  
  long s = millis();
  blockSize =  20;
  int f[] = of.getOpticalFlow(prev, cap, blockSize, 4, 4);
  long e = millis();
  
 
  int stepX = prev.width/blockSize;
  int stepY = prev.height/blockSize;
  for (int i = 0; i < stepX; i++) {
    for (int j = 0; j < stepY; j++) {
      //println(f[j*320/20+i]);
      float x = map(i, 0, stepX, 0, width);
      float y = map(j, 0, stepY, 0, height);
 
      line(x, y, x+f[j*stepX+i], y+f[f.length/2+j*stepX+i]);
    }
  }
 
  prev = new PImage(320, 200);
  arraycopy(cap.pixels, prev.pixels);

}

void keyPressed() {
  if (key == 's') {
    cap.settings();
  }
}

